function triggerTitle(title) {
  var span = title.getElementsByClassName("fa")
  if (span && span[0]) {
    span = span[0]
    var iconv = span.getAttribute("iconv")
    var iconh = span.getAttribute("iconh")
    var list = span.classList
    if (list.contains(iconv)) {
      list.remove(iconv)
      list.add(iconh)
    }
    else if (list.contains(iconh)) {
      list.remove(iconh)
      list.add(iconv)
    }
  }
}

function hidePanel(panel,show,fade) {
  require(['jquery'], function($){
    var content = $(".xm-panel-content",panel)
    if (show===0 && fade === 0) {
      content.css("opacity",0).hide()
    }
    else {
      content.animate({opacity:0},fade,"swing",function(){
        $(this).hide(show,function(){
          panel.classList.remove("xm-panel-visible")
          panel.classList.add("xm-panel-hidden")
        })
      })
    }
  })
}

function showPanel(panel,show,fade) {
  require(['jquery'], function($){
    var content = $(".xm-panel-content",panel)
    if (show === 0 && fade === 0) {
      content.show().css("opacity",0)
    }
    else {
      content.show(fade,function(){
        $(this).animate({opacity:1},show,function(){
          panel.classList.remove("xm-panel-hidden")
          panel.classList.add("xm-panel-visible")
        })
      })
    }
  })
}

function triggerPanel(panel){
  var title = panel.getElementsByClassName("xm-panel-title")[0]
  if (title) triggerTitle(title)
  if (panel.classList.contains("xm-panel-visible")) hidePanel(panel,150,150)
  else if (panel.classList.contains("xm-panel-hidden")) showPanel(panel,150,150)
}

var panels = document.getElementsByClassName("xm-panel-triggerable")
for (var i = 0; i<panels.length; ++i) {
  var panel = panels[i]
  var title = panel.getElementsByClassName("xm-panel-title")[0]
  if (title) {
    title.addEventListener("click",function(){
      triggerPanel(this.parentNode)
    })
  }
  if (panel.classList.contains("xm-panel-hidden")) hidePanel(panel,0,0)
}
